"""
Module defining main client flow on the network
"""
import sys
from threading import Thread
import time

import sslkeylog

from . import normal_traffic, send_advertisement, key_sharing

sslkeylog.set_keylog(key_sharing.sslkeylog_handler)

try:
    DELAY = 1.0  # in seconds
    COUNT = 0
    VERSION = 1
    while True:
        COUNT += 1
        if COUNT > 5:
            VERSION = 2
        print(COUNT)
        time.sleep(DELAY)
        if COUNT % 3 == 0:
            Thread(target=normal_traffic.main()).start()
        if COUNT % 5 == 0:
            Thread(target=send_advertisement.main(VERSION)).start()
except KeyboardInterrupt:
    sys.exit()
