-- Your SQL goes here
CREATE TABLE IF NOT EXISTS policies (
    policy_uuid		TEXT NOT NULL PRIMARY KEY,
    rev_num			INTEGER NOT NULL,
    certificate		TEXT
    );

CREATE TABLE IF NOT EXISTS clients (
    client_id		SERIAL NOT NULL PRIMARY KEY,
    ipv4_addr		TEXT,
	ipv6_addr		TEXT,
    hostname		TEXT NOT NULL
    );

CREATE TABLE IF NOT EXISTS policyclients (
    policy_uuid		TEXT NOT NULL,
    client_id		INTEGER,
    PRIMARY KEY (policy_uuid, client_id)
    );

CREATE TABLE IF NOT EXISTS rules (
    policy_uuid           	TEXT NOT NULL,
    rule_num            	INTEGER,
    action              	TEXT NOT NULL,
    ipv4_remote_addr		TEXT,
    ipv6_remote_addr		TEXT,
    tcp_remote_port			INTEGER,
    udp_remote_port			INTEGER,
    PRIMARY KEY (policy_uuid, rule_num)
    );

CREATE TABLE IF NOT EXISTS notifications (
    policy_uuid			TEXT NOT NULL,
    notification_id		INTEGER,
    email				TEXT,
    rest_api			TEXT,
    PRIMARY KEY (policy_uuid, notification_id)
    );

CREATE TABLE IF NOT EXISTS rulenotifications (
    policy_uuid         TEXT NOT NULL,
    rule_num			INTEGER,
    notification_id		INTEGER,
    PRIMARY KEY (policy_uuid, rule_num, notification_id)
    );

CREATE TABLE IF NOT EXISTS tags (
    policy_uuid		TEXT NOT NULL,
    tag_name		TEXT NOT NULL,
    PRIMARY KEY (policy_uuid, tag_name)
    );
