table! {
    clients (client_id) {
        client_id -> Int4,
        ipv4_addr -> Nullable<Text>,
        ipv6_addr -> Nullable<Text>,
        hostname -> Text,
    }
}

table! {
    notifications (policy_uuid, notification_id) {
        policy_uuid -> Text,
        notification_id -> Int4,
        email -> Nullable<Text>,
        rest_api -> Nullable<Text>,
    }
}

table! {
    policies (policy_uuid) {
        policy_uuid -> Text,
        rev_num -> Int4,
        certificate -> Nullable<Text>,
    }
}

table! {
    policyclients (policy_uuid, client_id) {
        policy_uuid -> Text,
        client_id -> Int4,
    }
}

table! {
    rulenotifications (policy_uuid, rule_num, notification_id) {
        policy_uuid -> Text,
        rule_num -> Int4,
        notification_id -> Int4,
    }
}

table! {
    rules (policy_uuid, rule_num) {
        policy_uuid -> Text,
        rule_num -> Int4,
        action -> Text,
        ipv4_remote_addr -> Nullable<Text>,
        ipv6_remote_addr -> Nullable<Text>,
        tcp_remote_port -> Nullable<Int4>,
        udp_remote_port -> Nullable<Int4>,
    }
}

table! {
    tags (policy_uuid, tag_name) {
        policy_uuid -> Text,
        tag_name -> Text,
    }
}

allow_tables_to_appear_in_same_query!(
    clients,
    notifications,
    policies,
    policyclients,
    rulenotifications,
    rules,
    tags,
);
