#!/bin/bash

FILENAME="$1"
rm -rf $FILENAME
> $FILENAME
echo "writing to $FILENAME"
echo "TIME_STAMP, VIRT, RES, SHR, %CPU, %MEM" | tee -a $FILENAME
while :
do
DATE=`date +"%H:%M:%S:%s%:z"`
echo -n "$DATE, " | tee -a $FILENAME
# break apart the info from the top command
LINE=`top -b -n 1 | grep -w python | tr -s ' '`
# VIRT is total amount of memory consumed by a process
VIRT=`echo $LINE | cut -d ' ' -f 5`
echo -n "$VIRT, " | tee -a $FILENAME
# RES is the memory consumed by a process in RAM
RES=`echo $LINE | cut -d ' ' -f 6`
echo -n "$RES, " | tee -a $FILENAME
# SHR is the amount of memory shared with other processes
SHR=`echo $LINE | cut -d ' ' -f 7`
echo -n "$SHR, " | tee -a $FILENAME
# CPU usage
CPU=`echo $LINE | cut -d ' ' -f 9`
echo -n "$CPU, " | tee -a $FILENAME
# Expresses RES value as a percentage of the total RAM available
MEM=`echo $LINE | cut -d ' ' -f 10`
echo "$MEM" | tee -a $FILENAME
sleep 1
done
